# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::DataShare::Mgmt::V2019_11_01
  module Models
    #
    # A provider side share subscription data transfer object.
    #
    class ProviderShareSubscription < ProxyDto

      include MsRestAzure

      # @return [String] Email of the consumer who created the share
      # subscription
      attr_accessor :consumer_email

      # @return [String] Name of the consumer who created the share
      # subscription
      attr_accessor :consumer_name

      # @return [String] Tenant name of the consumer who created the share
      # subscription
      attr_accessor :consumer_tenant_name

      # @return [DateTime] created at
      attr_accessor :created_at

      # @return [String] Email of the provider who created the share
      attr_accessor :provider_email

      # @return [String] Name of the provider who created the share
      attr_accessor :provider_name

      # @return [DateTime] Shared at
      attr_accessor :shared_at

      # @return [String] share Subscription Object Id
      attr_accessor :share_subscription_object_id

      # @return [ShareSubscriptionStatus] Gets the status of share
      # subscription. Possible values include: 'Active', 'Revoked',
      # 'SourceDeleted', 'Revoking'
      attr_accessor :share_subscription_status


      #
      # Mapper for ProviderShareSubscription class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ProviderShareSubscription',
          type: {
            name: 'Composite',
            class_name: 'ProviderShareSubscription',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              consumer_email: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.consumerEmail',
                type: {
                  name: 'String'
                }
              },
              consumer_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.consumerName',
                type: {
                  name: 'String'
                }
              },
              consumer_tenant_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.consumerTenantName',
                type: {
                  name: 'String'
                }
              },
              created_at: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.createdAt',
                type: {
                  name: 'DateTime'
                }
              },
              provider_email: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.providerEmail',
                type: {
                  name: 'String'
                }
              },
              provider_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.providerName',
                type: {
                  name: 'String'
                }
              },
              shared_at: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.sharedAt',
                type: {
                  name: 'DateTime'
                }
              },
              share_subscription_object_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.shareSubscriptionObjectId',
                type: {
                  name: 'String'
                }
              },
              share_subscription_status: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.shareSubscriptionStatus',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
